public class Algoritmo {

  private double [][][] Distancia2;

  private boolean [][] Ativo;
  private double [][] Raio;
  private Figura Grafo;
  private int Iteracao;

  private VArestas ArestasFloresta;
  private UnionFind Floresta[];

  // Inicia uma execuo do algoritmo em 'g'.
  public Algoritmo(Figura g) {
    Grafo = g;

    Distancia2 = new double [Grafo.n()][Grafo.n()][Grafo.n()];
    Ativo = new boolean [Grafo.n()][Grafo.n()];
    Raio = new double [Grafo.n()][Grafo.n()];
    Iteracao = 0;

    ArestasFloresta = new VArestas(29);
    Floresta = new UnionFind[Grafo.n()];
    Floresta[Iteracao] = new UnionFind(Grafo.n());

    for (int i = 0; i < Grafo.n(); i++) {
      for (int j = 0; j < Grafo.n(); j++) {
        Distancia2[Iteracao][i][j] = distancia2(Grafo.vertice(i),
                                                Grafo.vertice(j));
        Ativo[i][j] = false;
        Raio[i][j] = 0;
      }
    }
    for (int i = 0; i < Grafo.n(); i++)
      if (!Grafo.semSubconjunto(i)) Ativo[Iteracao][i] = true;

    // Obs: apenas metade da matriz Distancia2  usada...
  }

  // Devolve o nmero de arestas da floresta.
  public int mf() { return ArestasFloresta.size(); }
  public int numArestasFloresta() { return mf(); }

  public double raio2Atual(int v) { return Raio[Iteracao][v]; }
  public double raio2(int it, int vert) { return Raio[it][vert]; }
  public int iteracao() { return Iteracao; }
  public boolean ativo(int vert) { return Ativo[Iteracao][vert]; }
  public boolean ativo(int it, int vert) { return Ativo[it][vert]; }

  // Devolve a aresta de ndice i da floresta. Devolve null se o ndice for
  // invlido.
  public Aresta arestaFloresta(int i) {
    return ArestasFloresta.elementAt(i);
  }

  // Insere a aresta pq na floresta, onde i e j so os ndices dos vrtices
  // p e q.
  private void insereArestaFloresta(int i, int j) {
    Aresta a = new Aresta(Grafo.vertice(i), Grafo.vertice(j));
    if (ArestasFloresta.contains(a)) return;
    ArestasFloresta.addElement(a);
  }


  public boolean avanca() {

for (int i = 0; i < Ativo[0].length; i++)
System.out.print(i+"."+Ativo[Iteracao][i]+" ");
System.out.println();

    /* Encontra o "par mais-prximo", em O(n) mesmo... */

    int v1 = -1, v2 = -1;
    double min = Double.MAX_VALUE;
    double dist = 0;
    for (int i = 0; i < Grafo.n(); i++) {
      for(int j = i + 1; j < Grafo.n(); j++) {
        if (Floresta[Iteracao].find(i) == Floresta[Iteracao].find(j)){System.out.println("foo" + i + " "+j); continue;}
        if (!Grafo.eAresta(i, j)) continue;
        if (Ativo[Iteracao][i]) {
          if (Ativo[Iteracao][j])
            dist = Distancia2[Iteracao][i][j]/4;
          else
            dist = Distancia2[Iteracao][i][j];
        }
        else {
          if (Ativo[Iteracao][j])
            dist = Distancia2[Iteracao][i][j];
          else
            dist = Double.MAX_VALUE;
        }


        if (dist < min) {
          min = dist;
          v1 = i;
          v2 = j;
        }
      } // for j
    } // for i

    // par mais-prximo  v1 e v2, min  a distncia ao quadrado
System.out.println(v1+","+v2+"  "+ min);
    insereArestaFloresta(v1, v2);
    Floresta[Iteracao+1] = (UnionFind)Floresta[Iteracao].clone();
    Floresta[Iteracao+1].union(v1, v2);

    /* Atualiza as distncias ("cresce" os crculos) */

    double m = Math.sqrt(min);
    for (int i = 0; i < Grafo.n(); i++) {
      if (Ativo[Iteracao][i]) {
        for (int j = i + 1; j < Grafo.n(); j++) {
          double d = Math.sqrt(Distancia2[Iteracao][i][j]);
          if (Ativo[Iteracao][j]) {
            Distancia2[Iteracao+1][i][j] = Distancia2[Iteracao][i][j] - 4*m*d + 4*min;
System.out.println("aa "+i+" "+j+" "+Distancia2[Iteracao+1][i][j]);
          }
          else {
            Distancia2[Iteracao+1][i][j] = Distancia2[Iteracao][i][j] - 2*m*d + min;
System.out.println("ai "+i+" "+j+" "+Distancia2[Iteracao+1][i][j]);
          }
        }
      }
      else {
        for (int j = i + 1; j < Grafo.n(); j++) {
          double d = Math.sqrt(Distancia2[Iteracao][i][j]);
          if (Ativo[Iteracao][j])
            Distancia2[Iteracao+1][i][j] = Distancia2[Iteracao][i][j]-2*m*d + min;
          else
            Distancia2[Iteracao+1][i][j] = Distancia2[Iteracao][i][j];
        }
      }
    }

    // Atualiza os raios dos crculos:
    for (int i = 0; i < Grafo.n(); i++) {
      if (Ativo[Iteracao][i]) {
        double d = Math.sqrt(Raio[Iteracao][i]);
        Raio[Iteracao+1][i] = Raio[Iteracao][i] + 2*d*m + min;
//        Raio[Iteracao+1][i] = Raio[Iteracao][i] + m;
      }
      else
        Raio[Iteracao+1][i] = Raio[Iteracao][i];
System.out.print(i+"="+Raio[Iteracao+1][i]+ " ");
    }
System.out.println();


    /* Atualiza os ativos */

    Iteracao++;

    for (int i = 0; i < Floresta[Iteracao].size(); i++)
      Ativo[Iteracao][i] = Ativo[Iteracao - 1][i];

    int fv = Floresta[Iteracao].find(v1);
    for (int i = 0; i < Floresta[Iteracao].size(); i++) {
      if (Floresta[Iteracao].find(i) == fv) {  // para cada vrtice da floresta fv
        int subc = Grafo.subconjunto(i);
        int cont = 0;
        for (int j = 0; j < Floresta[Iteracao].size(); j++) {
          if (Floresta[Iteracao].find(j) == fv) { // para cada outro vrtice de fv
            if (Grafo.subconjunto(j) == subc) // se i  do mesmo conj de j
              cont++;
          }
        }
        if (cont < Grafo.tamSubconjunto(i)) { // todos so ativos
          for (int k = 0; k < Floresta[Iteracao].size(); k++)
            if (Floresta[Iteracao].find(k) == fv) Ativo[Iteracao][k] = true;
          break;
        }
        Ativo[Iteracao][i] = false;
System.out.println("foo");
      }
    }

for (int i = 0; i < Ativo[0].length; i++)
System.out.print(i+"."+Ativo[Iteracao][i]+" ");
System.out.println();
System.out.println("Fim Iteracao " + Iteracao);


    /* V se ainda tem trabalho */
    for (int i = 0; i < Ativo[0].length; i++)
      if (Ativo[Iteracao][i] == true) return true;
    return false;
  } // avanca

  public boolean volta() {
    if (Iteracao == 0) return false;
    Iteracao--;
    ArestasFloresta.removeElementAt(ArestasFloresta.size() - 1);
    return true;
  }



  private static int square(int a) { return a*a; }

  private static int distancia2(Ponto a, Ponto b) {
    return square(b.x() - a.x()) + square(b.y() - a.y());
  }

  public void imprime() {
    System.out.println("Floresta: ");
    for (int i = 0; i < ArestasFloresta.size(); i++)
      System.out.print(ArestasFloresta.elementAt(i) + " ");
    System.out.println();
  }


}