//

import java.awt.Frame;
import java.util.*;
import java.io.*;


public class Interface extends Frame{

  private static String nomeDoProg = "Interface";

  public Interface(Figura G)
    {
       MinFSGrafico p = new MinFSGrafico(G);
       add("Center", p);
       setSize(600,600);
       show();

       try {
       while(p.avanca()); System.in.read();
       while(p.volta()) System.in.read();
       } catch( IOException io){}
    }

  public static void main(String args[])
    {
      if (args.length < 1)
        {
          System.out.println("Erro nos argumentos!");
          System.out.println("Argumento 1: arquivo de pontos");
          System.exit(1);
	}
      FileInputStream in = null;
      try {
        in = new FileInputStream(args[0]);
      }
      catch(FileNotFoundException fnfe) {}

      Figura G = new Figura();

      le(in, G);

      Interface t = new Interface(G);
    }


  public static void le(InputStream inStream, Figura G) {
    try {
      BufferedReader buf = new BufferedReader(new InputStreamReader(inStream));
      int l = 0; // linha
      String linha = null;
      StringTokenizer tok = null;

      /* Pontos */

      l++; linha = buf.readLine();
      tok = new StringTokenizer(linha);
      int numPontos = Integer.parseInt(tok.nextToken());
      if (tok.hasMoreTokens())
        aviso("l" + l + ": ignorando restante da linha.");

      for (int i = 0; i < numPontos; i++) {
        int x, y;
        l++; linha = buf.readLine();
        if (linha == null) {
          erro("l" + l + ": eu esperava " + numPontos + " pontos.");
        }
        tok = new StringTokenizer(linha);
        if (!tok.hasMoreTokens())
          aviso("l" + l + ": linha em branco.");
        x = Integer.parseInt(tok.nextToken());
        if (!tok.hasMoreTokens()) {
          erro("l" + l + ": eu esperava 2 valores.");
        }
        y = Integer.parseInt(tok.nextToken());
        if (tok.hasMoreTokens())
          aviso("l" + l + ": ignorando restante da linha.");
        G.insereVertice(new Ponto(x,y));
      }

      /* Arestas */  // ainda no implementado

      l++; linha = buf.readLine();
      tok = new StringTokenizer(linha);
      int numArestas = Integer.parseInt(tok.nextToken());
      if (tok.hasMoreTokens())
        aviso("l" + l + ": ignorando restante da linha.");
      if (numArestas < 0)
        G.completa();
      else {
        for (int i = 0; i < numArestas; i++)
          l++; linha = buf.readLine();
      }

      /* Subconjuntos */

      l++; linha = buf.readLine();
      tok = new StringTokenizer(linha);
      int numSubconj = Integer.parseInt(tok.nextToken());
      if (tok.hasMoreTokens())
        aviso("l" + l + ": ignorando restante da linha.");
      boolean escolhido[] = new boolean[numPontos];
      for (int i = 0; i < numPontos; i++) escolhido[i] = false;

      if (numSubconj < 0) {
        // Une todos os pontos:
        for (int i = 0; i < numPontos - 1; i++)
          G.une(i, i + 1);
        G.une(numPontos - 1, 0);
      }
      for (int i = 0; i < numSubconj; i++) {
        l++; linha = buf.readLine();
        if (linha == null) {
          erro("l" + l + ": eu esperava " + numSubconj + " subconjutos.");
        }
        tok = new StringTokenizer(linha);
        if (!tok.hasMoreTokens()) {
          aviso("l" + l + ": linha em branco.");
          continue;
        }
        int c, rep;
        rep = Integer.parseInt(tok.nextToken());
        if (escolhido[rep]) aviso("l" + l + ": rep j est em outro subconjunto.");
        escolhido[rep] = true;
        while (tok.hasMoreTokens()) {
          c = Integer.parseInt(tok.nextToken());
          if (escolhido[c]) aviso("l" + l + ": c j est em outro subconjunto.");
          escolhido[c] = true;
          G.une(rep,c);
        }
      }

    }
    catch (IOException e) {}

  }

  // Imprime uma mensagem de erro, mas sem terminar o programa.
  public static void aviso(String msg) {
    System.err.println(nomeDoProg + ": " + msg);
  }

  // Imprime uma mensagem de erro.
  public static void erro(String msg) {
    System.err.println(nomeDoProg + ": " + msg);
  }
}