import java.awt.*;
import java.math.*;

public class MinFSGrafico extends Canvas {
  Color [] paleta;
  int conj = 0;
  int cor = 0;

  Figura G;
  Algoritmo Algo;

  MinFSGrafico(Figura grafo)
   {
     paleta = new Color [9];
     /*for (int i = 0; i < 7; i++)
       paleta[i] = new Color();*/
     paleta[1] = Color.red;
     paleta[2] = Color.orange;
     paleta[3] = Color.yellow;
     paleta[4] = Color.green;
     paleta[5] = Color.blue;
     paleta[6] = Color.magenta;
     paleta[7] = Color.cyan.darker();
     paleta[0] = Color.pink;
     G = grafo;
     Algo = new Algoritmo(G);

   }

  public void paint(Graphics g)
    {

      // Crculos
      for (int j = Algo.iteracao(); j > 0; j--)
	{
	  g.setColor(paleta[j % paleta.length]);
          for (int i = 0; i < G.n(); i++)
            {
	      int x = G.vertice(i).x();
	      int y = G.vertice(i).y();
	      int dim = (int)Math.sqrt(Algo.raio2(j, i));
              if (Algo.ativo(j-1, i)) {
                g.drawOval(x - dim, y - dim, 2*dim, 2*dim);
                g.fillOval(x - dim, y - dim, 2*dim, 2*dim);
              }
	    }
	}


      // Arestas do grafo
/*      for (int i = 0; i < G.numArestas(); i++)
        {
	  int x1, y1, x2, y2;
	  x1 = G.aresta(i).ini().x();
	  y1 = G.aresta(i).ini().y();
	  x2 = G.aresta(i).fim().x();
	  y2 = G.aresta(i).fim().y();
	  g.setColor(Color.cyan.brighter());
          g.drawLine(x1, y1, x2, y2);
	}

*/
      // Arestas da floresta
      for (int i = 0; i < Algo.numArestasFloresta(); i++)
        {
	  int x1, y1, x2, y2;
	  x1 = Algo.arestaFloresta(i).ini().x();
	  y1 = Algo.arestaFloresta(i).ini().y();
	  x2 = Algo.arestaFloresta(i).fim().x();
	  y2 = Algo.arestaFloresta(i).fim().y();
	  g.setColor(Color.black);
          g.drawLine(x1, y1, x2, y2);
	}

      // Vrtices
      for (int i = 0; i < G.n(); i++)
        {
          if (G.semSubconjunto(i))
            g.setColor(Color.black);
          else
            g.setColor(paleta[(G.subconjunto(i) + 4) % paleta.length].brighter().brighter());
	  int x = G.vertice(i).x();
	  int y = G.vertice(i).y();
          g.drawOval(x-2, y-2, 5, 5);
          g.fillOval(x-2, y-2, 5, 5);
	}

      // Labels dos vrtices
      for (int i = 0; i < G.n(); i++)
        {
	  g.setColor(Color.black);
	  int x = G.vertice(i).x();
	  int y = G.vertice(i).y();
          g.drawString(String.valueOf(i), x+10, y+10);
	}

    }

  public boolean avanca() {
    boolean ret = Algo.avanca();
    repaint();
    return ret;
  }

  public boolean volta() {
    boolean ret = Algo.volta();
    repaint();
    return ret;
  }
  public boolean mouseDown(Event evt, int x, int y)
    {
      Algo.avanca();
      repaint();
      return true;
    }


}
